C     ******************************************************************
C     *                                                                *
C     *       ANALYSIS OF SOIL HYDRAULIC PROPERTIES          RETC.FOR  *
C     *                                                                *
C     *       FOR MORE INFORMATION, CONTACT:                           *
C     *                                                                *
C     *             RIEN VAN GENUCHTEN OR FEIKE LEIJ                   *
C     *             U. S. SALINITY LABORATORY                          *
C     *             USDA-ARS                                           *
C     *             450 BOX SPRING ROAD                                *
C     *             RIVERSIDE, CA  92507                               *
C     *                                                                *
C     *             TELEPHONE (909) 369-4846                           *
C     *             FAX       (909) 369-4818                           *
C     *                                                                *
C     *       VERSION OF JUNE, 1991;  LAST UPDATED 11-21-1994          *
C     *                                                                *
C     ******************************************************************
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION X(200),Y(200),R(200),F(200),DELZ(100,7),W(200),B(14),
     *E(7),P(7),PHI(7),Q(7),TB(14),A(7,7),D(7,7),INDEX(7),TH(14)
      CHARACTER AB(14)*5,TITLE*60,HEAD*60,PRNS*1
      CHARACTER*12 INF,OTF,RETPLT,CONPLT
      DATA STOPCR/.00010/
  999 CALL USR_IN(INF,OTF,RETPLT,CONPLT,TITLE,MTYPE,
     *METHOD,KWATER,KIN,KOUT,KITER,MIT,AB,B,INDEX,W1,NW)
      KP=7
C
C     ----- OPEN I/O FILES -----
      IF((INF.EQ.'*MISSING*').AND.(KWATER.NE.3)) THEN
      CALL CLR
      WRITE(0,995)
  995 FORMAT(10(/),14X,'CANNOT FIND INPUT FILE.  SPECIFY AN EXISTING INP
     *UT FILE')
      CALL PAUS
      GO TO 999
      ENDIF
      IF(KWATER.NE.3) OPEN(5,FILE=INF,STATUS='UNKNOWN')
      CALL CLR
      WRITE(0,998) 
  998 FORMAT(10(/),14X,'SEND OUTPUT TO PRINTER AND/OR OUTPUT FILE'
     */14X,'P - To printer only'
     */14X,'B - To both printer and output file'
     */14X,'F - To output file only (or just hit Enter)'
     *//14X,'SELECT:',\)
      READ(0,'(A)') PRNS
      IF((PRNS.EQ.'P').OR.(PRNS.EQ.'p')) OPEN(7,FILE='PRN')
      IF((PRNS.EQ.'B').OR.(PRNS.EQ.'b')) THEN
      OPEN(7,FILE='PRN')
      OPEN(8,FILE=OTF,STATUS='UNKNOWN')
      KP=8
      ENDIF
      IF((PRNS.EQ.'F').OR.(PRNS.EQ.'f')) THEN
      OPEN(7,FILE=OTF,STATUS='UNKNOWN')
      ENDIF
      IF((PRNS.EQ.' ').OR.(PRNS.EQ.'  ')) THEN
      OPEN(7,FILE=OTF,STATUS='UNKNOWN')
      ENDIF
C
C     ----- READ EXPERIMENTAL DATA -----
      IF(KWATER.NE.3) READ(5,'(A60)',END=996) HEAD
      NWC=0
      NOB=0
      IF(KWATER.EQ.3) GO TO 994
      DO 997 I=1, 10000
      READ(5,*,END=996) XX,YY,WW
      IF(XX .GE. 0) THEN
      NOB=NOB+1
      X(NOB)=XX
      Y(NOB)=YY
      W(NOB)=WW
      ELSE
      NWC=NOB
      ENDIF
  997 CONTINUE
  996 IF(NWC.EQ.0) NWC=NOB
  994 CONTINUE
C
C     ----- READ INPUT PARAMETERS -----
      IF(KWATER.EQ.3) MIT=0
      IF(KWATER.EQ.3) KOUT=1
      IF(NOB.EQ.0) MIT=0
      IF(NOB.EQ.0) KOUT=1
      IF((NWC.EQ.0).AND.(KWATER.NE.3)) KWATER=2
      IF(MTYPE.LT.1.OR.MTYPE.GT.6) MTYPE=3
C
C     ----- READ INITIAL ESTIMATES -----
      IF(KWATER.EQ.1) INDEX(6)=0
      IF(KWATER.EQ.1) INDEX(7)=0
      IF(KWATER.EQ.2.AND.METHOD.LE.2) INDEX(3)=0
      IF(KWATER.EQ.2.AND.METHOD.GE.5) INDEX(3)=0
C
      WRITE(KP,1008) TITLE
      IF(KP.EQ.8) WRITE(7,1008) TITLE
      GO TO (5,5,1,2,3,3) MTYPE
    1 B(11)=DMAX1(1.05D0,B(11))
      B(12)=1.-1./B(11)
      GO TO 4
    2 B(11)=DMAX1(2.05D0,B(11))
      B(12)=1.-2./B(11)
      GO TO 4
    3 B(11)=DMAX1(0.005,B(11))
      B(12)=1.0
    4 INDEX(5)=0
    5 CONTINUE
      IF(MTYPE.EQ.1) WRITE(KP,1010)
      IF(MTYPE.EQ.2) WRITE(KP,1011)
      IF(MTYPE.EQ.3) WRITE(KP,1012)
      IF(MTYPE.EQ.4) WRITE(KP,1014)
      IF(MTYPE.EQ.5) WRITE(KP,1015)
      IF(MTYPE.EQ.6) WRITE(KP,1016)
      IF(KP.EQ.8) THEN
      IF(MTYPE.EQ.1) WRITE(7,1010)
      IF(MTYPE.EQ.2) WRITE(7,1011)
      IF(MTYPE.EQ.3) WRITE(7,1012)
      IF(MTYPE.EQ.4) WRITE(7,1014)
      IF(MTYPE.EQ.5) WRITE(7,1015)
      IF(MTYPE.EQ.6) WRITE(7,1016)
      ENDIF
      KLOG=0
      IF(2*(METHOD/2).EQ.METHOD) KLOG=1
      IF(KWATER.EQ.1) KLOG=0
      IF(MIT.EQ.0) GO TO 6
      IF(KWATER.EQ.1) WRITE(KP,1017)
      IF(KWATER.EQ.0.AND.METHOD.LE.4) WRITE(KP,1018)
      IF(KWATER.EQ.0.AND.METHOD.GT.4) WRITE(KP,1019)
      IF(KWATER.EQ.2.AND.METHOD.LE.4) WRITE(KP,1020)
      IF(KWATER.EQ.2.AND.METHOD.GT.4) WRITE(KP,1021)
      IF(KLOG.EQ.1) WRITE(KP,1022)
      IF(KP.EQ.8) THEN
      IF(KWATER.EQ.1) WRITE(7,1017)
      IF(KWATER.EQ.0.AND.METHOD.LE.4) WRITE(7,1018)
      IF(KWATER.EQ.0.AND.METHOD.GT.4) WRITE(7,1019)
      IF(KWATER.EQ.2.AND.METHOD.LE.4) WRITE(7,1020)
      IF(KWATER.EQ.2.AND.METHOD.GT.4) WRITE(7,1021)
      IF(KLOG.EQ.1) WRITE(7,1022)
      ENDIF
      IF(KWATER.NE.2) GO TO 6
      IF(METHOD.LE.2.OR.METHOD.GT.4) GO TO 6
      INDEX(1)=0
      INDEX(2)=0
    6 WRITE(KP,1023) MTYPE,METHOD
      NP=0
      IF(NOB.GT.0) WRITE(KP,1024) (I,AB(I+7),B(I+7),INDEX(I),I=1,7)
      IF(NOB.EQ.0) WRITE(KP,1024) (I,AB(I+7),B(I+7),NP,I=1,7)
      IF(KP.EQ.8) THEN
      IF(KP.EQ.8) WRITE(7,1023) MTYPE,METHOD
      IF(NOB.GT.0) WRITE(7,1024) (I,AB(I+7),B(I+7),INDEX(I),I=1,7)
      IF(NOB.EQ.0) WRITE(7,1024) (I,AB(I+7),B(I+7),NP,I=1,7)
      ENDIF
      IF(NOB.EQ.0) GO TO 14
C
C     ----- WRITE EXPERIMENTAL DATA -----
      IF(KIN.EQ.1) WRITE(KP,1025)
      IF((KP.EQ.8).AND.(KIN.EQ.1)) WRITE(7,1025)
      WA=0.
      IF(KWATER.EQ.2) GO TO 8
      IF(KIN.EQ.1) WRITE(KP,1027)
      IF((KP.EQ.8).AND.(KIN.EQ.1)) WRITE(7,1027)
      DO 7 I=1,NWC
      X(I)=DMAX1(X(I),1.D-5)
      IF(W(I).LT.1.D-3) W(I)=1.0
      WA=WA+DABS(W(I)*Y(I))
      IF(KIN.EQ.0) GO TO 7
      WRITE(KP,1029) I,X(I),Y(I),W(I)
      IF(KP.EQ.8) WRITE(7,1029) I,X(I),Y(I),W(I)
    7 CONTINUE
      WA=WA/FLOAT(NWC)
      IF(KWATER.EQ.1) GO TO 14
    8 IF(KIN.EQ.0) GO TO 9
      IF(METHOD.EQ.1) WRITE(KP,1031)
      IF(METHOD.EQ.2) WRITE(KP,1032)
      IF(METHOD.EQ.3) WRITE(KP,1033)
      IF(METHOD.EQ.4) WRITE(KP,1034)
      IF(METHOD.EQ.5) WRITE(KP,1035)
      IF(METHOD.EQ.6) WRITE(KP,1036)
      IF(KP.EQ.8) THEN
      IF(METHOD.EQ.1) WRITE(7,1031)
      IF(METHOD.EQ.2) WRITE(7,1032)
      IF(METHOD.EQ.3) WRITE(7,1033)
      IF(METHOD.EQ.4) WRITE(7,1034)
      IF(METHOD.EQ.5) WRITE(7,1035)
      IF(METHOD.EQ.6) WRITE(7,1036)
      ENDIF
    9 WB=0.0
      IF(KWATER.EQ.2.AND.NWC.EQ.NOB) NWC=0
      NWC1=NWC+1
      DO 10 I=NWC1,NOB
      J=I
      IF(KWATER.EQ.2) J=I-NWC
      X(J)=X(I)
      IF(METHOD.EQ.3.OR.METHOD.EQ.4) X(J)=DMAX1(X(J),1.D-5)
      Y(J)=Y(I)
      IF(KLOG.EQ.1) Y(J)=DLOG10(Y(J))
      W(J)=W(I)
      IF(W(J).LT.1.D-3) W(J)=1.0
      WB=WB+DABS(W(J)*Y(J))
      IF(KIN.EQ.0) GO TO 10
      IF(KLOG.EQ.0) WRITE(KP,1037) J,X(J),Y(J),W(J)
      IF(KLOG.EQ.1) WRITE(KP,1038) J,X(J),Y(J),W(J)
      IF(KP.EQ.8) THEN
      IF(KLOG.EQ.0) WRITE(7,1037) J,X(J),Y(J),W(J)
      IF(KLOG.EQ.1) WRITE(7,1038) J,X(J),Y(J),W(J)
      ENDIF
   10 CONTINUE
      IF(KWATER.LT.2) GO TO 11
      NOB=NOB-NWC
      NWC=0
      NWC1=1
   11 IF(MIT.EQ.0) GO TO 14
      IF(W1.LT.1.D-3) W1=1.0
      WB=WB/FLOAT(NOB-NWC)
      W2=WA/WB
      IF(KWATER.EQ.2) W2=1.0
      W12=W1*W2
      WRITE(KP,1040) W1,W2,W12
      IF(KP.EQ.8) WRITE(7,1040) W1,W2,W12
      DO 12 I=NWC1,NOB
   12 W(I)=W12*W(I)
C
C      ----- INITIALIZE UNKNOWN PARAMETERS -----
   14 NP=0
      DO 15 I=8,14
      TB(I)=B(I)
      IF(INDEX(I-7).EQ.0) GO TO 15
      NP=NP+1
      AB(NP)=AB(I)
      B(NP)=B(I)
      TB(NP)=B(I)
      TH(NP)=B(I)
   15 TH(I)=B(I)
      IF(NOB.EQ.0) GO TO 92
      GA=0.05
      DERL=0.002D0
      NEXP=1+INDEX(1)+INDEX(2)+INDEX(3)+INDEX(4)+INDEX(5)
      IF(KWATER.EQ.1) NOB=NWC
C
C     ----- START LEAST-SQUARES ANALYSIS -----
      CALL MODEL(TH,F,X,NWC,NOB,MTYPE,METHOD,INDEX,IOR)
      IF(IOR.EQ.1) GO TO 94
      IF(MIT.EQ.0) GO TO 83
      SSQ=0.
      DO 16 I=1,NOB
      R(I)=W(I)*(Y(I)-F(I))
   16 SSQ=SSQ+R(I)*R(I)
      NIT=0
      WRITE(KP,1042) (AB(I),I=1,NP)
      WRITE(KP,1044) NIT,SSQ,(B(I),I=1,NP)
      IF(KP.EQ.8) THEN
      WRITE(7,1042) (AB(I),I=1,NP)
      WRITE(7,1044) NIT,SSQ,(B(I),I=1,NP)
      ENDIF
C
C     ----- BEGIN OF ITERATION -----
   18 NIT=NIT+1
      GA=0.05*GA
      DO 22 J=1,NP
      TEMP=TH(J)
      TH(J)=(1.D0+DERL)*TH(J)
      Q(J)=0
      CALL MODEL(TH,DELZ(1,J),X,NWC,NOB,MTYPE,METHOD,INDEX,IOR)
      IF(IOR.EQ.1) GO TO 94
      DO 20 I=1,NOB
      DELZ(I,J)=W(I)*(DELZ(I,J)-F(I))
   20 Q(J)=Q(J)+DELZ(I,J)*R(I)
      Q(J)=Q(J)/(TH(J)*DERL)
C
C     ----- STEEPEST DESCENT -----
   22 TH(J)=TEMP
      DO 28 I=1,NP
      DO 26 J=1,I
      SUM=0.0
      DO 24 K=1,NOB
   24 SUM=SUM+DELZ(K,I)*DELZ(K,J)
      D(I,J)=SUM/(TH(I)*TH(J)*DERL**2)
   26 D(J,I)=D(I,J)
   28 E(I)=DSQRT(D(I,I))
   30 DO 32 I=1,NP
      DO 32 J=1,NP
   32 A(I,J)=D(I,J)/(E(I)*E(J))
C
C     ----- A IS THE SCALED MOMENT MATRIX -----
      DO 34 I=1,NP
      P(I)=Q(I)/E(I)
      PHI(I)=P(I)
   34 A(I,I)=A(I,I)+GA
      CALL MATINV(A,NP,P)
C
C     ----- P/E IS THE CORRECTION VECTOR -----
      STEP=1.0
   36 DO 38 I=1,NP
   38 TB(I)=P(I)*STEP/E(I)+TH(I)
      DO 40 I=1,NP
      IF(TH(I)*TB(I))44,44,40
   40 CONTINUE
      CALL MODEL(TB,F,X,NWC,NOB,MTYPE,METHOD,INDEX,IOR)
      IF(IOR.EQ.1) GO TO 94
      SUMB=0.0
      DO 42 I=1,NOB
      R(I)=W(I)*(Y(I)-F(I))
   42 SUMB=SUMB+R(I)*R(I)
   44 SUM1=0.0
      SUM2=0.0
      SUM3=0.0
      DO 46 I=1,NP
      SUM1=SUM1+P(I)*PHI(I)
      SUM2=SUM2+P(I)*P(I)
   46 SUM3=SUM3+PHI(I)*PHI(I)
      ARG=SUM1/DSQRT(SUM2*SUM3)
      ARG1=0.
      IF(NP.GT.1) ARG1=DSQRT(1.-ARG*ARG)
      ANGLE=57.29578*DATAN2(ARG1,ARG)
C
C     ----------
      DO 48 I=1,NP
      IF(TH(I)*TB(I))50,50,48
   48 CONTINUE
      IF((SUMB-SSQ)/SSQ.LT.1.D-5) GO TO 56
   50 IF(ANGLE-30.D0) 52,52,54
   52 STEP=0.5*STEP
      GO TO 36
   54 GA=20.*GA
      GO TO 30
C
C     ----- PRINT COEFFICIENTS AFTER EACH ITERATION -----
   56 CONTINUE
      DO 58 I=1,14
   58 TH(I)=TB(I)
      IF(NIT.LT.KITER) WRITE(KP,1044) NIT,SUMB,(TH(I),I=1,NP)
      IF((KP.EQ.8).AND.(NIT.LT.KITER)) WRITE(7,1044) NIT,SUMB,
     *(TH(I),I=1,NP)
      IF(INDEX(1).EQ.0) GO TO 60
      IF(NIT.LE.4.OR.TH(1).GT.0.001) GO TO 60
      INDEX(1)=0
      B(8)=0.0
      IF(NIT.GE.KITER) WRITE(KP,1044) NIT,SUMB,(TH(I),I=1,NP)
      IF((KP.EQ.8).AND.(NIT.GE.KITER)) WRITE(7,1044) NIT,SUMB,
     *(TH(I),I=1,NP)
      WRITE(KP,1046)
      IF(KP.EQ.8) WRITE(7,1046)
      GO TO 14
   60 IF(INDEX(6).EQ.0) GO TO 64
      EXPO=TH(NEXP)
      IF(EXPO.GT.1.D-3) GO TO 64
      IF(EXPO.LT.-1.D-3) GO TO 64
      IF(EXPO.LT.0.) GO TO 62
      B(13)=-0.2
      GO TO 14
   62 B(13)=0.0001
      INDEX(6)=0
      WRITE(KP,1050) B(13)
      IF(KP.EQ.8) WRITE(7,1050) B(13)
      GO TO 14
   64 DO 66 I=1,NP
      IF(DABS(P(I)*STEP/E(I))/(1.D-20+DABS(TH(I)))-STOPCR) 66,66,68
   66 CONTINUE
      GO TO 70
   68 SSQ=SUMB
      IF(NIT.LE.MIT) GO TO 18
C
C     ----- END OF ITERATION LOOP -----
   70 CONTINUE
      IF(NIT.GE.KITER) WRITE(KP,1044) NIT,SUMB,(TH(I),I=1,NP)
      IF((KP.EQ.8).AND.(NIT.GE.KITER)) WRITE(7,1044) NIT,SUMB,
     *(TH(I),I=1,NP)
      CALL MATINV(D,NP,P)
C
C     ----- WRITE CORRELATION MATRIX -----
      DO 72 I=1,NP
   72 E(I)=DSQRT(DMAX1(D(I,I),1.D-20))
      IF(NP.EQ.1) GO TO 78
      WRITE(KP,1051) (AB(I),I=1,NP)
      IF(KP.EQ.8) WRITE(7,1051) (AB(I),I=1,NP)
      WRITE(KP,1052) (I,I=1,NP)
      IF(KP.EQ.8) WRITE(7,1052) (I,I=1,NP)
      DO 76 I=1,NP
      DO 74 J=1,I
   74 A(J,I)=D(J,I)/(E(I)*E(J))
      WRITE(KP,1054) I,(A(J,I),J=1,I)
   76 IF(KP.EQ.8) WRITE(7,1054) I,(A(J,I),J=1,I)
C
C     ----- CALCULATE R-SQUARED OF FITTED VS OBSERVED VALUES -----
   78 SUM=0.0
      SUMY=0.0
      SUMF=0.0
      SUMY2=0.0
      SUMF2=0.0
      SUMYF=0.0
      DO 80 I=1,NOB
      SUM=SUM+W(I)
      SUMY=SUMY+Y(I)*W(I)
      SUMF=SUMF+F(I)*W(I)
      SUMY2=SUMY2+Y(I)**2*W(I)
      SUMF2=SUMF2+F(I)**2*W(I)
   80 SUMYF=SUMYF+Y(I)*F(I)*W(I)
      RSQ=(SUMYF-SUMY*SUMF/SUM)**2/((SUMY2-SUMY**2/SUM)*(SUMF2-SUMF**2/
     1SUM))
      WRITE(KP,1056) RSQ
      IF(KP.EQ.8) WRITE(7,1056) RSQ
C
C     ----- CALCULATE 95% CONFIDENCE INTERVAL -----
      Z=1./FLOAT(NOB-NP)
      SDEV=DSQRT(Z*SUMB)
      WRITE(KP,1058)
      IF(KP.EQ.8) WRITE(7,1058)
      TVAR=1.96+Z*(2.3779+Z*(2.7135+Z*(3.187936+2.466666*Z**2)))
      DO 82 I=1,NP
      SECOEF=E(I)*SDEV
      TVALUE=TH(I)/SECOEF
      TVALUE=DMIN1(TVALUE,999999.D0)
      TSEC=TVAR*SECOEF
      TMCOE=TH(I)-TSEC
      TPCOE=TH(I)+TSEC
      IF(NP.EQ.1) WRITE(KP,1060) AB(I),TH(I),SECOEF,TMCOE,TPCOE
      IF((KP.EQ.8).AND.(NP.EQ.1)) WRITE(7,1060) AB(I),TH(I),SECOEF,
     *TMCOE,TPCOE
      IF(NP.GT.1) WRITE(KP,1062) AB(I),TH(I),SECOEF,TVALUE,TMCOE,TPCOE
   82 IF((KP.EQ.8).AND.(NP.GT.1)) WRITE(7,1062) AB(I),TH(I),SECOEF,
     *TVALUE,TMCOE,TPCOE
C
C     ----- GIVE FINAL OUTPUT -----
   83 IF(MIT.GT.0) WRITE(KP,1063)
      IF(MIT.EQ.0) WRITE(KP,1064)
      IF(KP.EQ.8) THEN
      IF(MIT.GT.0) WRITE(7,1063)
      IF(MIT.EQ.0) WRITE(7,1064)
      ENDIF
      SSQ1=0.0
      SSQ2=0.0
      SSQW1=0.0
      SSQW2=0.0
      IF(KWATER.EQ.2) GO TO 85
      WRITE(KP,1065)
      IF(KP.EQ.8) WRITE(7,1065)
      DO 84 I=1,NWC
      XLOG=DLOG10(DMAX1(1.D-5,X(I)))
      R(I)=Y(I)-F(I)
      SSQ1=SSQ1+R(I)**2
      SSQW1=SSQW1+(R(I)*W(I))**2
      IF(KP.EQ.8) WRITE(7,1066) I,X(I),XLOG,Y(I),F(I),R(I)
   84 WRITE(KP,1066) I,X(I),XLOG,Y(I),F(I),R(I)
      IF(KWATER.EQ.1) GO TO 89
C
C     ----- WRITE CONDUCTIVITY OR DIFFUSIVITY DATA -----
   85 IF(METHOD.EQ.1) WRITE(KP,1068)
      IF(METHOD.EQ.2) WRITE(KP,1069)
      IF(METHOD.EQ.3) WRITE(KP,1070)
      IF(METHOD.EQ.4) WRITE(KP,1071)
      IF(METHOD.EQ.5) WRITE(KP,1072)
      IF(METHOD.EQ.6) WRITE(KP,1073)
      IF(KP.EQ.8) THEN
      IF(METHOD.EQ.1) WRITE(7,1068)
      IF(METHOD.EQ.2) WRITE(7,1069)
      IF(METHOD.EQ.3) WRITE(7,1070)
      IF(METHOD.EQ.4) WRITE(7,1071)
      IF(METHOD.EQ.5) WRITE(7,1072)
      IF(METHOD.EQ.6) WRITE(7,1073)
      ENDIF
      DO 88 I=NWC1,NOB
      R(I)=Y(I)-F(I)
      SSQ2=SSQ2+R(I)**2
      SSQW2=SSQW2+(R(I)*W(I))**2
      RLX=DLOG10(DMAX1(1.D-30,X(I)))
      RLY=DLOG10(DMAX1(1.D-30,Y(I)))
      RPZ=10.**DMIN1(3.D1,Y(I))
      RLF=DLOG10(DMAX1(1.D-30,F(I)))
      RPF=10.**DMIN1(3.D1,F(I))
      IF(METHOD.EQ.1.OR.METHOD.EQ.5) WRITE(KP,1074) I,X(I),Y(I),F(I),
     1R(I),RLY,RLF
      IF(METHOD.EQ.2.OR.METHOD.EQ.6) WRITE(KP,1075) I,X(I),Y(I),F(I),
     1R(I),RPZ,RPF
      IF(METHOD.EQ.3) WRITE(KP,1076) I,X(I),RLX,Y(I),F(I),R(I),RLY
      IF(METHOD.EQ.4) WRITE(KP,1077) I,X(I),RLX,Y(I),F(I),R(I),RPZ
      IF(KP.EQ.8) THEN
      IF(METHOD.EQ.1.OR.METHOD.EQ.5) WRITE(7,1074) I,X(I),Y(I),F(I),
     1R(I),RLY,RLF
      IF(METHOD.EQ.2.OR.METHOD.EQ.6) WRITE(7,1075) I,X(I),Y(I),F(I),
     1R(I),RPZ,RPF
      IF(METHOD.EQ.3) WRITE(7,1076) I,X(I),RLX,Y(I),F(I),R(I),RLY
      IF(METHOD.EQ.4) WRITE(7,1077) I,X(I),RLX,Y(I),F(I),R(I),RPZ
      ENDIF
   88 CONTINUE
   89 IF(MIT.EQ.0) GO TO 90
      SSQ=SSQ1+SSQ2
      SSQW=SSQW1+SSQW2
      WRITE(KP,1078) SSQ1,SSQW1,SSQ2,SSQW2,SSQ,SSQW
      IF(KP.EQ.8) WRITE(7,1078) SSQ1,SSQW1,SSQ2,SSQW2,SSQ,SSQW
   90 CONTINUE
   92 IF(KOUT.EQ.1) CALL PRINT(RETPLT,CONPLT,KP,MTYPE,TH,METHOD,NW)
   94 IF(IOR.EQ.1) WRITE(1080)
      WRITE(KP,1082)
      WRITE(KP,'(A2)') CHAR(12)
      IF(KP.EQ.8) THEN
      WRITE(7,1082)
      WRITE(7,'(A2)') CHAR(12)
      ENDIF
      CLOSE(5)
      CLOSE(7)
      GO TO 999
C
C     ----- END OF PROBLEM -----
 1000 FORMAT(10I5)
 1002 FORMAT(A60)
 1004 FORMAT(8F10.0)
 1008 FORMAT(5X,67(1H*)/5X,1H*,65X,1H*/5X,1H*,5X,'ANALYSIS OF SOIL HYDRA
     1ULIC PROPERTIES',23X,1H*/5X,1H*,65X,1H*/5X,1H*,5X,A60,1H*/5X,1H*,
     265X,1H*)
 1010 FORMAT(5X,1H*,5X,'VARIABLE N AND M (MUALEM-THEORY FOR K)',22X,1H*)
 1011 FORMAT(5X,1H*,5X,'VARIABLE N AND M (BURDINE-THEORY FOR K)',21X,1H*
     1)
 1012 FORMAT(5X,1H*,5X,'MUALEM-BASED RESTRICTION, M=1-1/N',27X,1H*)
 1014 FORMAT(5X,1H*,5X,'BURDINE-BASED RESTRICTION, M=1-2/N',26X,1H*)
 1015 FORMAT(5X,1H*,5X,'BROOKS AND COREY EQUIVALENT (MUALEM)',24X,1H*)
 1016 FORMAT(5X,1H*,5X,'BROOKS AND COREY EQUIVALENT (BURDINE)',23X,1H*)
 1017 FORMAT(5X,1H*,5X,'ANALYSIS OF RETENTION DATA ONLY',29X,1H*)
 1018 FORMAT(5X,1H*,5X,'SIMULTANEOUS FIT OF RETENTION AND CONDUCTIVITY D
     1ATA',9X,1H*)
 1019 FORMAT(5X,1H*,5X,'SIMULTANEOUS FIT OF RETENTION AND DIFFUSIVITY DA
     1TA',10X,1H*)
 1020 FORMAT(5X,1H*,5X,'ANALYSIS OF CONDUCTIVITY DATA ONLY',26X,1H*)
 1021 FORMAT(5X,1H*,5X,'ANALYSIS OF DIFFUSIVITY DATA ONLY',27X,1H*)
 1022 FORMAT(5X,1H*,5X,'FIT ON LOG-TRANSFORMED K/D DATA',29X,1H*)
 1023 FORMAT(5X,1H*,5X,'MTYPE=',I2,5X,'METHOD=',I2,38X,1H*/5X,1H*,65X,
     11H*/5X,67(1H*))
 1024 FORMAT(//5X,'INITIAL VALUES OF THE COEFFICIENTS'/5X,34(1H=)/5X,'NO
     1',6X,'NAME',8X,'INITIAL VALUE',3X,'INDEX'/(4X,I3,5X,A6,4X,F12.4,7X
     2,I3))
 1025 FORMAT(///5X,'OBSERVED DATA'/5X,13(1H=))
 1027 FORMAT(5X,'OBS. NO.',4X,'PRESSURE HEAD',5X,'WATER CONTENT',5X,'WEI
     1GHTING COEFFICIENT')
 1029 FORMAT(5X,I5,4X,F12.3,7X,F12.4,7X,F12.4)
 1031 FORMAT(16X,'WATER CONTENT',6X,'CONDUCTIVITY',5X,'WEIGHTING COEFFIC
     1IENT')
 1032 FORMAT(16X,'WATER CONTENT',4X,'LOG-CONDUCTIVITY',3X,'WEIGHTING COE
     1FFICIENT')
 1033 FORMAT(16X,'PRESSURE HEAD',6X,'CONDUCTIVITY',5X,'WEIGHTING COEFFIC
     1IENT')
 1034 FORMAT(16X,'PRESSURE HEAD',4X,'LOG-CONDUCTIVITY',3X,'WEIGHTING COE
     1FFICIENT')
 1035 FORMAT(16X,'WATER CONTENT',6X,'DIFFUSIVITY',6X,'WEIGHTING COEFFICI
     1ENT')
 1036 FORMAT(16X,'WATER CONTENT',4X,'LOG-DIFFUSIVITY',4X,'WEIGHTING COEF
     1FICIENT')
 1037 FORMAT(5X,I5,4X,F12.4,8X,E12.4,7X,F12.4)
 1038 FORMAT(5X,I5,4X,F12.4,7X,F12.4,7X,F12.4)
 1040 FORMAT(/5X,'WEIGHTING COEFFICIENTS'/5X,22(1H=)/5X,'W1=',F9.5,4X,
     1'W2=',F9.5,5X,'W12=',F9.5)
 1042 FORMAT(//5X,'NIT',5X,'SSQ',2X,7(2X,A6))
 1044 FORMAT(4X,I3,F11.5,7F8.4)
 1046 FORMAT(//5X,'WCR IS LESS THEN 0.001: CHANGED TO FIT WITH WCR=0.0')
 1050 FORMAT(40X,'EXPO FIXED AT ',F8.6)
 1051 FORMAT(//5X,'CORRELATION MATRIX'/5X,18(1H=)/9X,8(2X,A5,3X))
 1052 FORMAT(8X,10(4X,I2,4X))
 1054 FORMAT(4X,I3,10(2X,F7.4,1X))
 1056 FORMAT(//5X,'RSQUARED FOR REGRESSION OF OBSERVED VS FITTED VALUES
     1=',F11.8/5X,65(1H=))
 1058 FORMAT(//5X,'NONLINEAR LEAST-SQUARES ANALYSIS: FINAL RESULTS'/
     15X,47(1H=)/51X,'95% CONFIDENCE LIMITS'/5X,'VARIABLE',5X,'VALUE',
     25X,'S.E.COEFF.',4X,'T-VALUE',5X,'LOWER',7X,'UPPER')
 1060 FORMAT(5X,A6,F13.5,F12.5,9X,'--',2X,2F11.4)
 1062 FORMAT(5X,A6,F13.5,F12.5,4X,F9.2,2F11.4)
 1063 FORMAT(//5X,'OBSERVED AND FITTED DATA'/5X,24(1H=))
 1064 FORMAT(//5X,'OBSERVED AND CALCULATED VALUES (FOR CALCULATED VALUES
     1'/5X,29(1H=),'  USE THE ENTRIES LABELED "FIT")')
 1065 FORMAT(5X,'NO',9X,'P',9X,'LOG-P',4X,'WC-OBS',4X,'WC-FIT',4X,'WC-DE
     1V')
 1066 FORMAT(4X,I3,E14.4,4F10.4)
 1068 FORMAT(/12X,'WC',6X,'K-OBS',7X,'K-FIT',7X,'K-DEV',6X,'LOGK-OBS',
     12X,'LOGK-FIT')
 1069 FORMAT(/12X,'WC',5X,'LOGK-OBS',2X,'LOGK-FIT',2X,'LOGK-DEV',
     13X,'K-OBS',7X,'K-FIT')
 1070 FORMAT(/15X,'P',7X,'LOG-P',4X,'K-OBS',7X,'K-FIT',7X,'K-DEV',
     15X,'LOGK-OBS')
 1071 FORMAT(/15X,'P',7X,'LOG-P',3X,'LOGK-OBS',2X,'LOGK-FIT',2X,
     1'LOGK-DEV',4X,'K-OBS')
 1072 FORMAT(/12X,'WC',6X,'D-OBS',7X,'D-FIT',7X,'D-DEV',6X,'LOGD-OBS',
     12X,'LOGD-FIT')
 1073 FORMAT(/12X,'WC',5X,'LOGD-OBS',2X,'LOGD-FIT',2X,'LOGD-DEV',
     14X,'D-OBS',7X,'D-FIT')
 1074 FORMAT(4X,I3,F9.4,3E12.4,2F10.4)
 1075 FORMAT(4X,I3,F9.4,3F10.4,2E12.4)
 1076 FORMAT(4X,I3,E13.4,F8.4,3E12.4,F10.4)
 1077 FORMAT(4X,I3,E13.4,F8.4,3F10.4,E12.4)
 1078 FORMAT(//5X,'SUM OF SQUARES OF OBSERVED VERSUS FITTED VALUES'/5X,
     147(1H=)/22X,'UNWEIGHTED',3X,'WEIGHTED'/5X,'RETENTION DATA',2F12.5/
     25X,'COND/DIFF DATA',2F12.5/11X,'ALL DATA',2F12.5)
 1080 FORMAT(/5X,'PARAMETER N IS TOO SMALL, THIS CASE IS NOT EXECUTED')
 1082 FORMAT(//5X,'END OF PROBLEM'/5X,14(1H=)/)
      END
C
C     ------------------------------------------------------------------
      SUBROUTINE MODEL(B,Y,X,NWC,NOB,MTYPE,METHOD,INDEX,IOR)
C
C     PURPOSE: TO CALCULATE THE HYDRAULIC PROPERTIES
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION B(14),Y(200),X(200),INDEX(7)
      K=0
      IOR=0
      DO 2 I=8,14
      IF(INDEX(I-7).EQ.0) GO TO 2
      K=K+1
      B(I)=B(K)
    2 CONTINUE
      WCR=B(8)
      WCS=B(9)
      ALPHA=B(10)
      IND=INDEX(1)+INDEX(2)+INDEX(3)+INDEX(4)
      IF(MTYPE.EQ.1.OR.MTYPE.EQ.3) B(11)=DMAX1(1.005D0,B(11))
      IF(MTYPE.EQ.3) B(12)=1.-1./B(11)
      IF(MTYPE.EQ.2.OR.MTYPE.EQ.4) B(11)=DMAX1(2.005D0,B(11))
      IF(MTYPE.EQ.4) B(12)=1.-2./B(11)
    4 IF(INDEX(4).EQ.1) B(IND)=B(11)
      RN=B(11)
      RM=B(12)
      EXPO=B(13)
      CONDS=B(14)
      RMN=RM*RN
      DLGA=DLOG10(ALPHA)
      RMT=FLOAT(MTYPE-2*((MTYPE-1)/2))
      IF(NOB.EQ.NWC) GO TO 12
C
C     -----CALCULATE COMPLETE BETA FUNCTION-----
      IF(MTYPE.GT.2) GO TO 10
      AA=RM+RMT/RN
      BB=1.-RMT/RN
      IF(BB.GT.0.004) GO TO 8
      IOR=1
      GO TO 60
    8 BETA=GAMMA(AA)*GAMMA(BB)/GAMMA(RM+1.)
      WCL=DMAX1(2./(2.+RM),0.2D0)
      DLG1=(3.0-RMT)*DLOG10(RN/(BETA*(RMN+RMT)))
   10 DLG2=3.0-RMT+EXPO+2.0/RMN
      DLG3=DLOG10(RMN*ALPHA*(WCS-WCR))
      DLG4=DLOG10(CONDS)
      DLGC=-35.0
      DLGD=-35.0
C
C     ----- CALCULATE FUNCTIONAL VALUES Y(I) -----
   12 DO 54 I=1,NOB
      IF(METHOD.EQ.3.OR.METHOD.EQ.4) GO TO 13
      IF(I.GT.NWC) GO TO 28
   13 AX=ALPHA*X(I)
      IF(AX.LT.1.D-20) GO TO 16
      EX=RN*DLOG10(AX)
      IF(MTYPE.LT.5) GO TO 14
      IF(AX.LE.1.) GO TO 16
      IF(EX.GT.10.) GO TO 20
      GO TO 22
   14 IF(EX.GT.-10.) GO TO 18
   16 RWC=1.0
      GO TO 26
   18 IF(EX.LT.10.) GO TO 24
      EX=RM*EX
      IF(EX.LT.30.) GO TO 22
   20 RWC=0.0
      GO TO 26
   22 RWC=AX**(-RM*RN)
      GO TO 26
   24 RWC=(1.+AX**RN)**(-RM)
   26 Y(I)=WCR+(WCS-WCR)*RWC
      IF(I.LE.NWC) GO TO 54
      GO TO 30
C
C     ----- CONDUCTIVITY DATA -----
   28 RWC=(X(I)-WCR)/(WCS-WCR)
   30 IF(RWC.GT.1.D-10) GO TO 31
      DLGC=-30
      DLGD=-30
      COND=1.D-30
      DIF=1.D-30
      GO TO 50
   31 IF(RWC.LT.0.999999D0) GO TO 32
      DLGC=DLG4
      COND=CONDS
      DLGD=30.0
      DIF=1.D30
      GO TO 50
   32 DLGW=DLOG10(RWC)
      DLGC=DLG2*DLGW+DLG4
      DLGD=DLGC-DLG3-(RMN+1)*DLGW/RMN
      IF(DLGC.LT.-30..OR.DLGW.LT.(-15.*RM)) GO TO 48
      IF(MTYPE.GT.4) GO TO 46
      DW=RWC**(1./RM)
      IF(MTYPE.GT.2) GO TO 42
C
C     ----- MTYPE = 1 OR 2 (VARIABLE M,N) -----
      IF(DW.GT.1.D-06) GO TO 34
      DLGC=DLGC+DLG1
      DLGD=DLGC-DLG3-(RMN+1.)*DLGW/RMN
      GO TO 48
   34 IF(RWC-WCL) 36,36,38
   36 TERM=BINC(DW,AA,BB,BETA)
      GO TO 44
   38 TERM=1.-BINC(1.-DW,BB,AA,BETA)
      GO TO 44
C
C     ----- MTYPE = 3 OR 4 (RESTRICTED M,N) -----
   42 A=DMIN1(0.999999D0,DMAX1(1.D-7,1.-DW))
      TERM=1.D0-A**RM
      IF(DW.LT.1.D-04) TERM=RM*DW*(1.-0.5*(RM-1.)*DW)
   44 RELK=RWC**EXPO*TERM
      IF(RMT.LT.1.5) RELK=RELK*TERM
      DLGC=DLOG10(RELK)+DLG4
      DLGD=DLGC-DLG3-(RMN+1.)*DLGW/RMN-(RN-1.)*DLOG10(1.-DW)/RN
      GO TO 48
C
C     ----- MTYPE = 5 OR 6 -----
   46 DLGD=DLG4-DLG3+(2.0-RMT+EXPO+1./RN)*DLGW
   48 DLGC=DMAX1(-30.D0,DLGC)
      DLGD=DMAX1(-30.D0,DLGD)
      DLGD=DMIN1(30.D0,DLGD)
      COND=10.**DLGC
      DIF=10.**DLGD
   50 IF(METHOD.EQ.1.OR.METHOD.EQ.3) Y(I)=COND
      IF(METHOD.EQ.2.OR.METHOD.EQ.4) Y(I)=DLGC
      IF(METHOD.EQ.5) Y(I)=DIF
      IF(METHOD.EQ.6) Y(I)=DLGD
 1000 FORMAT(I5,6D13.5)
   54 CONTINUE
   60 CONTINUE
      RETURN
      END
C
C     ------------------------------------------------------------------
      SUBROUTINE MATINV(A,NP,B)
C
C     PURPOSE: TO INVERT THE MATRIX FOR PARAMETER ESTIMATION
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(7,7),B(7),INDEX(7,2)
      DO 2 J=1,7
    2 INDEX(J,1)=0
      I=0
    4 AMAX=-1.0
      DO 12 J=1,NP
      IF(INDEX(J,1)) 12,6,12
    6 DO 10 K=1,NP
      IF(INDEX(K,1)) 10,8,10
    8 P=ABS(A(J,K))
      IF(P.LE.AMAX) GO TO 10
      IR=J
      IC=K
      AMAX=P
   10 CONTINUE
   12 CONTINUE
      IF(AMAX) 30,30,14
   14 INDEX(IC,1)=IR
      IF(IR.EQ.IC) GO TO 18
      DO 16 L=1,NP
      P=A(IR,L)
      A(IR,L)=A(IC,L)
   16 A(IC,L)=P
      P=B(IR)
      B(IR)=B(IC)
      B(IC)=P
      I=I+1
      INDEX(I,2)=IC
   18 P=1./A(IC,IC)
      A(IC,IC)=1.0
      DO 20 L=1,NP
   20 A(IC,L)=A(IC,L)*P
      B(IC)=B(IC)*P
      DO 24 K=1,NP
      IF(K.EQ.IC) GO TO 24
      P=A(K,IC)
      A(K,IC)=0.0
      DO 22 L=1,NP
   22 A(K,L)=A(K,L)-A(IC,L)*P
      B(K)=B(K)-B(IC)*P
   24 CONTINUE
      GO TO 4
   26 IC=INDEX(I,2)
      IR=INDEX(IC,1)
      DO 28 K=1,NP
      P=A(K,IR)
      A(K,IR)=A(K,IC)
   28 A(K,IC)=P
      I=I-1
   30 IF(I) 26,32,26
   32 RETURN
      END
C
C     ------------------------------------------------------
      FUNCTION GAMMA(Z)
C
C     PURPOSE:  TO CALCULATE THE GAMMA FUNCTION FOR POSITIVE Z
C
      IMPLICIT REAL*8 (A-H,O-Z)
      IF(Z.LT.33.) GO TO 2
      GAMMA=1.D36
      RETURN
    2 X=Z
      GAMMA=1.0
      IF(X-2.0) 10,10,8
    6 IF(X-2.0) 14,14,8
    8 X=X-1.0
      GAMMA=GAMMA*X
      GO TO 6
   10 IF(X-1.0) 12,16,14
   12 GAMMA=GAMMA/X
      X=X+1.0
   14 Y=X-1.0
      FY=1.0-Y*(.5771017-Y*(.985854-Y*(.8764218-Y*(.8328212-Y*(.5684729-
     2Y*(.2548205-.0514993*Y))))))
      GAMMA=GAMMA*FY
   16 RETURN
      END
C
C     ------------------------------------------------------
      FUNCTION BINC(X,A,B,BETA)
C
C     PURPOSE: TO CALCULATE THE INCOMPLETE BETA-FUNCTION
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION T(200)
      DATA NT/10/
      NT1=NT+1
      T(1)=-(A+B)*X/(A+1.0)
      DO 2 I=2,NT,2
      Y=FLOAT(I/2)
      Y2=FLOAT(I)
      T(I)=Y*(B-Y)*X/((A+Y2-1.0)*(A+Y2))
    2 T(I+1)=-(A+Y)*(A+B+Y)*X/((A+Y2)*(A+Y2+1.0))
      BINC=1.0
      DO 4 I=1,NT
      K=NT1-I
    4 BINC=1.+T(K)/BINC
      BINC=X**A*(1.-X)**B/(BINC*A*BETA)
      RETURN
      END
C
C     ------------------------------------------------------------------
      SUBROUTINE PRINT(RETPLT,CONPLT,KP,MTYPE,TH,METHOD,NW)
C
C     PURPOSE: TO PRINT THE SOIL-HYDRAULIC PROPERTIES
C
      IMPLICIT REAL*8(A-H,O-Z)
      CHARACTER*12 RETPLT,CONPLT
      DIMENSION TH(14)
      WRITE(KP,1000) MTYPE
      IF(KP.EQ.8) WRITE(7,1000) MTYPE
      WCR=TH(8)
      WCS=TH(9)
      ALPHA=TH(10)
      RN=TH(11)
      RM=TH(12)
      EXPO=TH(13)
      CONDS=TH(14)
      COND=0.0
      DIF=0.0
      RMN=RM*RN
      DLGA=DLOG10(ALPHA)
      RMT=FLOAT(MTYPE-2*((MTYPE-1)/2))
      IF(MTYPE.GT.2) GO TO 4
      AA=RM+RMT/RN
      BB=1.-RMT/RN
      IF(BB.GT.0.004) GO TO 2
      WRITE(KP,1002) RN
      IF(KP.EQ.8) WRITE(7,1002) RN
      GO TO 28
    2 BETA=GAMMA(AA)*GAMMA(BB)/GAMMA(RM+1.)
      WCL=DMAX1(2./(2.+RM),0.2D0)
      DLG1=(3.0-RMT)*DLOG10(RN/(BETA*(RMN+RMT)))
    4 DLG2=3.0-RMT+EXPO+2.0/RMN
      DLG3=DLOG10(RMN*ALPHA*(WCS-WCR))
      DLG4=DLOG10(CONDS)
C
C     ----- CALCULATE CURVE -----
      OPEN(5,FILE=RETPLT,STATUS = 'UNKNOWN')
      OPEN(6,FILE=CONPLT,STATUS = 'UNKNOWN')
      DWC=1.0/FLOAT(NW-2)
      DO 24 I=1,NW
      RWC=FLOAT(I-2)*DWC
      IF(I.EQ.1) RWC=0.25*DWC
      IF(I.EQ.2) RWC=0.5*DWC
      IF(I.EQ.NW) RWC=1.-0.5*DWC
      WC=WCR+(WCS-WCR)*RWC
      DLGW=DLOG10(RWC)
      DLGC=DLG2*DLGW+DLG4
      DLGP=-DLGA-DLGW/RMN
      IF(DLGW.GT.(-6.*RM).AND.MTYPE.LT.5) DLGP=DLGP+DLOG10(1.-RWC**(1./
     1RM))/RN
      IF(DLGP.GT.20..OR.DLGC.LT.-30..OR.DLGW.LT.(-15.*RM)) GO TO 24
      PP=10.**DLGP
      IF(MTYPE.GT.4) GO TO 18
      DW=RWC**(1./RM)
      IF(MTYPE.GT.2) GO TO 14
      IF(DW.GT.1.D-06) GO TO 6
      DLGC=DLGC+DLG1
      DLGD=DLGC-DLG3-(RMN+1.)*DLGW/RMN
      GO TO 20
    6 IF(RWC-WCL) 8,8,10
    8 TERM=BINC(DW,AA,BB,BETA)
      GO TO 16
   10 TERM=1.-BINC(1.-DW,BB,AA,BETA)
      GO TO 16
   14 TERM=1.-RWC*(ALPHA*PP)**RMN
      IF(DW.LT.1.D-04) TERM=RM*DW*(1.-0.5*(RM-1.)*DW)
   16 RELK=RWC**EXPO*TERM
      IF(RMT.LT.1.5) RELK=RELK*TERM
      DLGC=DLOG10(RELK)+DLG4
      DLGD=DLGC-DLG3-(RMN+1.)*DLGW/RMN-(RN-1.)*DLOG10(1.-DW)/RN
      GO TO 20
   18 DLGD=DLG4-DLG3+(2.0-RMT+EXPO+1./RN)*DLGW
   20 IF(ABS(DLGC).LT.35.) COND=10.**DLGC
      IF(ABS(DLGD).LT.35.) DIF=10.**DLGD
      WRITE(KP,1004) WC,PP,DLGP,COND,DLGC,DIF,DLGD
      IF(KP.EQ.8) WRITE(7,1004) WC,PP,DLGP,COND,DLGC,DIF,DLGD
      WRITE(5,1004) WC,PP
      IF(METHOD.EQ.1.OR.METHOD.EQ.2) THEN
      WRITE(6,1004) WC,COND
      ELSE IF(METHOD.EQ.3.OR.METHOD.EQ.4) THEN
      WRITE(6,1010) PP,COND
      ELSE IF(METHOD.EQ.5.OR.METHOD.EQ.6) THEN
      WRITE(6,1004) WC,DIF
      ENDIF
   24 CONTINUE
      IF(MTYPE.GT.4) GO TO 26
      PP=0.
      WRITE(KP,1006) WCS,PP,CONDS,DLG4
      IF(KP.EQ.8) WRITE(7,1006) WCS,PP,CONDS,DLG4
      IF(METHOD.EQ.1.OR.METHOD.EQ.2) THEN
      WRITE(6,1004) WC,CONDS
      ELSE IF(METHOD.EQ.3.OR.METHOD.EQ.4) THEN
      WRITE(6,1010) PP,CONDS
      ENDIF
      GO TO 28
   26 PP=1./ALPHA
      DLGP=DLOG10(PP)
      DLGD=DLG4-DLG3
      DIF=10.**DLGD
      WRITE(KP,1004) WCS,PP,DLGP,CONDS,DLG4,DIF,DLGD
      IF(KP.EQ.8) WRITE(7,1004) WCS,PP,DLGP,CONDS,DLG4,DIF,DLGD
      IF(METHOD.EQ.1.OR.METHOD.EQ.2) THEN
      WRITE(6,1004) WC,CONDS
      ELSE IF(METHOD.EQ.3.OR.METHOD.EQ.4) THEN
      WRITE(6,1010) PP,CONDS
      ELSE IF(METHOD.EQ.5.OR.METHOD.EQ.6) THEN
      WRITE(6,1004) WC,DIF
      ENDIF
   28 CONTINUE
      CLOSE(5)
      CLOSE(6)
C
C     ----------
 1000 FORMAT(//5X,'SOIL HYDRAULIC PROPERTIES (MTYPE =',I2,')'/5X,37(1H=)
     1/8X,'WC',8X,'P',8X,'LOGP',5X,'COND',7X,'LOGK',7X,'DIF',7X,'LOGD')
 1002 FORMAT(//5X,'PARAMETER N IS TOO SMALL (N=',F8.5,'): THIS CASE IS N
     1OT EXECUTED')
 1004 FORMAT(4X,F7.4,E13.4,F7.3,2(E13.4,F8.3))
 1006 FORMAT(4X,F7.4,E13.4,7X,E13.4,F8.3)
 1010 FORMAT(4X,E13.4,7X,E13.4)
      RETURN
      END
C
C     ******************************************************************
C     *                                                                *
C     *                    USER INTERFACE FOR RETC                     *
C     *    DEVELOPED BY W.B. RUSSELL, FEIKE J. LEIJ AND R. ZHANG       *
C     *                                                                *
C     *                          JANUARY, 1991                         *
C     *                                                                *
C     ******************************************************************
C     ------------------------------------------------------------------
      SUBROUTINE USR_IN(INF,OTF,RETPLT,CONPLT,TITLE,MTYPE,
     *METHOD,KWATER,KIN,KOUT,KITER,MIT,AB,B,INDEX,W1,NW)
C
C     PURPOSE: INITIATE INTERACTIVE, MENU DRIVEN PROGRAM.
C
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION B(14),INDEX(7)
      CHARACTER*60 TITLE
      CHARACTER*5 AB(14)
C     CHARACTER*60 FORM
      CHARACTER*12 INF,OTF,RETPLT,CONPLT
      LOGICAL QEX
      INQUIRE (FILE='RETC.CTL', EXIST=QEX)
      IF(LP.EQ.1) GO TO 100
      IF(.NOT.QEX) CALL CREATE_CTL(INF,OTF,RETPLT,CONPLT,TITLE,MTYPE,
     *METHOD,KWATER,KIN,KOUT,KITER,MIT,AB,B,INDEX,W1,NW)
    1 CALL GET_FI(INF,OTF,RETPLT,CONPLT,TITLE,MTYPE,
     *METHOD,KWATER,KIN,KOUT,KITER,MIT,AB,B,INDEX,W1,NW)
    3 CALL WR1_SC(INF,OTF,RETPLT,CONPLT,TITLE,MTYPE)
      CALL GET_VA(INF,OTF,RETPLT,CONPLT,TITLE,MTYPE,
     *METHOD,KWATER,KIN,KOUT,KITER,MIT,AB,B,INDEX,W1,NW,IANS)
      IF(IANS.NE.0) GO TO 3
    6 CALL WR2_SC(METHOD,KWATER,KIN,KOUT,KITER)
      CALL GET_VA(INF,OTF,RETPLT,CONPLT,TITLE,MTYPE,
     *METHOD,KWATER,KIN,KOUT,KITER,MIT,AB,B,INDEX,W1,NW,IANS)
      IF(IANS.NE.0) GO TO 6
    9 CALL WR3_SC(KWATER,MIT,AB,B,INDEX,W1,NW)
      CALL GET_VA(INF,OTF,RETPLT,CONPLT,TITLE,MTYPE,
     *METHOD,KWATER,KIN,KOUT,KITER,MIT,AB,B,INDEX,W1,NW,IANS)
      IF(IANS.NE.0) GO TO 9
  100 LP = 1
    4 CALL GET_OP(IOP)
      IF(IOP.NE.-1) THEN
        IF(IOP.EQ.4) CALL STOPS
        IF(IOP.EQ.5) THEN
          CALL VI_FI(INF,OTF,RETPLT,CONPLT)
          GO TO 4
        ENDIF
        IF(IOP.EQ.1) GO TO 3
        IF(IOP.EQ.2) THEN
          CALL FI_EX(OTF,2)
          CALL FI_EX(RETPLT,3)
          CALL FI_EX(CONPLT,4)
        ENDIF
        IF(IOP.EQ.3) THEN
          CALL WRI_FI(INF,OTF,RETPLT,CONPLT,TITLE,MTYPE,
     *     METHOD,KWATER,KIN,KOUT,KITER,MIT,AB,B,INDEX,W1,NW)
          CALL STOPS
        ENDIF
      ELSE
        CONTINUE
      ENDIF
      END
C
C     ------------------------------------------------------------------
      SUBROUTINE CREATE_CTL(INF,OTF,RETPLT,CONPLT,TITLE,MTYPE,
     *METHOD,KWATER,KIN,KOUT,KITER,MIT,AB,B,INDEX,W1,NW)
C
C     PURPOSE: CREATE A CONTROL FILE RETC.CTL AND WRITE TO DISK
C
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION B(14),INDEX(7)
      CHARACTER*60 TITLE
      CHARACTER*5 AB(14)
      CHARACTER*12 INF,OTF,RETPLT,CONPLT
      CALL CR1_SC(INF,OTF,RETPLT,CONPLT,TITLE,MTYPE)
      CALL CR2_SC(METHOD,KWATER,KIN,KOUT,KITER)
      CALL CR3_SC(KWATER,MIT,AB,B,INDEX,W1,NW,MTYPE)
      OPEN(5,FILE = 'RETC.CTL',STATUS = 'NEW')
      WRITE(5,1000) INF,OTF,RETPLT,CONPLT
      WRITE(5,1010) TITLE
      WRITE(5,1015) MTYPE,METHOD,KWATER,KIN,KOUT,KITER,MIT
      WRITE(5,1020) (AB(I),I=8,14)
      WRITE(5,1025) (B(I),I=8,14)
      WRITE(5,1028) (INDEX(I),I=1,7)
      WRITE(5,1030) W1,NW
 1000 FORMAT(A12/A12/A12/A12)
 1005 FORMAT(2I5)
 1010 FORMAT(A60)
 1015 FORMAT(7I5)
 1020 FORMAT(7A5)
 1025 FORMAT(7F10.5)
 1028 FORMAT(7I5)
 1030 FORMAT(F10.0,I5)
      CLOSE(5)
      RETURN
      END
C
C     ------------------------------------------------------------------
      SUBROUTINE CR1_SC(INF,OTF,RETPLT,CONPLT,TITLE,MTYPE)
C
C     PURPOSE: CREATE FIRST PART OF CONTROL FILE
C
      IMPLICIT REAL*8(A-H,O-Z)
      CHARACTER*60 TITLE
      CHARACTER*12 INF,OTF,RETPLT,CONPLT
      CALL CLR
      WRITE(0,1040)
 1040 FORMAT(20(1H*),'  CREATE A CONTROL FILE: RETC.CTL  ',20(1H*))
      WRITE(*,1045)
      READ(*,'(A12)') INF
      WRITE(*,1048)
      READ(*,'(A12)') OTF
 1045 FORMAT(T8,'INPUT OBSERVED DATA FILE NAME',T57,':'\)
 1048 FORMAT(T8,'GIVE OUTPUT FILE NAME',T57,':'\)
      WRITE(*,1050)
      READ(*,'(A12)') RETPLT
 1050 FORMAT(T8,'INPUT PLOT FILE NAME FOR RETETION CURVE',T57,':'\)
      WRITE(*,1052)
      READ(*,'(A12)') CONPLT
 1052 FORMAT(T8,'INPUT PLOT FILE NAME FOR CONDUCTIVITY/DIFFUSIVITY:'\)
      WRITE(0,1054)
      READ(0,'(A55)') TITLE
 1054 FORMAT(T8,'INPUT TITLE OF CASE ',T57,':'/,T12\)
      WRITE(0,1057)
      MTYPE=INT_RANGE(1,6)
 1057 FORMAT(T8,'TYPE OF RETENTION/CONDUCTIVITY MODEL:'/
     *            T10,'1. Retention: van Genuchten'/
     *            T10,'   Conductivity: Mualem'/
     *            T10,'2. Retention: van Genuchten'/
     *            T10,'   Conductivity: Burdine'/
     *            T10,'3. Retention: van Genuchten with m=1-1/n'/
     *            T10,'   Conductivity: Mualem'/
     *            T10,'4. Retention: van Genuchten with m=1-2/n'/
     *            T10,'   Conductivity: Burdine'/
     *            T10,'5. Retention: Brooks & Corey'/
     *            T10,'   Conductivity: Mualem'/
     *            T10,'6. Retention: Brooks & Corey'/
     *            T10,'   Conductivity: Burdine'/
     * T8,'INPUT YOUR CHOICE (1 - 6)',T57,':'\)
      RETURN
      END
C
C     ------------------------------------------------------------------
      SUBROUTINE CR2_SC(METHOD,KWATER,KIN,KOUT,KITER)
C
C     PURPOSE: CREATE SECOND PART OF A CONTROL FILE
C
      IMPLICIT REAL*8(A-H,O-Z)
      CALL CLR
      WRITE(0,1040)
 1040 FORMAT(20(1H*),'  CREATE A CONTROL FILE: RETC.CTL  ',20(1H*))
      WRITE(0,1066)
      METHOD=INT_RANGE(1,6)
      WRITE(0,1067)
      KWATER=INT_RANGE(0,3)
 1066 FORMAT(T8,'TYPE OF CONDUCTIVITY/DIFFUSIVITY INPUT DATA:
     *'/ T10,'1. Conductivity vs. water content'/
     *   T10,'2. As 1 with internal log transformation of conductivity'/
     *   T10,'3. Conductivity vs. pressure head'/
     *   T10,'4. As 3 with internal log transformation of conductivity'/
     *   T10,'5. Diffusivity vs. water content'/
     *   T10,'6. As 5 with internal log transformation of diffusivity'/
     *T8,'INPUT YOUR CHOICE (1 - 6)',T65,':'\)
 1067 FORMAT(T8,'TYPE OF FITTING:'/
     *   T10,'0. Fit to retention and conductivity/diffusivity data'/
     *   T10,'1. Fit to retention data only'/
     *   T10,'2. Fit to conductivity/diffusivity data only'/
     *   T10,'3. No fitting (forward problem)'/
     *T8,'INPUT YOUR CHOICE (0 - 3)',T65,':'\)
      WRITE(0,1070)
      KIN=INT_RANGE(0,1)
      WRITE(0,1075)
      KOUT=INT_RANGE(0,1)
      WRITE(0,1080)
      KITER=INT_RANGE(0,1000000)
 1070 FORMAT(T8,'INPUT CHOICE TO PRINT OBSERVED DATA BEFORE FITTING'/
     *T12,'(0=Skip;1=Print)',T65,':'\)
 1075 FORMAT(T8,'INPUT CHOICE TO PRINT ALL SOIL HYDRAULIC PROPERTIES AFT
     *ER FITTING',/T12,'(0=Skip;1=Print)',T65,':'\)
 1080 FORMAT(T8,'INPUT CHOICE TO PRINT IMPROVED ESTIMATES FOR FITTING
     *'/T10,'PARAMETERS DURING FIRST KITER ITERATIONS (KITER)',
     * T65,':'\)
C
      RETURN
      END
C
C     ------------------------------------------------------------------
      SUBROUTINE CR3_SC(KWATER,MIT,AB,B,INDEX,W1,NW,MTYPE)
C
C     PURPOSE: CREATE THIRD PART OF A CONTROL FILE
C
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION B(14),INDEX(7)
      CHARACTER*5 AB(14)
      CALL CLR
      WRITE(0,1040)
 1040 FORMAT(20(1H*),'  CREATE A CONTROL FILE: RETC.CTL  ',20(1H*))
      WRITE(0,1068)
      MIT=INT_RANGE(0,1000000)
 1068 FORMAT(T8,'INPUT MAXIMUM NUMBER OF ITERATIONS ',T56,':'\)
      WRITE(0,1070)
      READ(0,'(A5)') AB(8)
      WRITE(0,1075)
      READ(0,'(A5)') AB(9)
      WRITE(0,1080)
      READ(0,'(A5)') AB(10)
      WRITE(0,1085)
      READ(0,'(A5)') AB(11)
      WRITE(0,1088)
      READ(0,'(A5)') AB(12)
      WRITE(0,1090)
      READ(0,'(A5)') AB(13)
      WRITE(0,1092)
      READ(0,'(A5)') AB(14)
 1070 FORMAT(T8,'INPUT A VARIABLE NAME FOR RESIDUAL WATER CONTENT',T56,
     *':'\)
 1075 FORMAT(T8,'INPUT A VARIABLE NAME FOR SATURATED WATER CONTENT',T56,
     *':'\)
 1080 FORMAT(T8,'INPUT A VARIABLE NAME FOR PARAMETER Alpha',T56,':'\)
 1085 FORMAT(T8,'INPUT A VARIABLE NAME FOR PARAMETER n',T56,':'\)
 1088 FORMAT(T8,'INPUT A VARIABLE NAME FOR PARAMETER m',T56,':'\)
 1090 FORMAT(T8,'INPUT A VARIABLE NAME FOR PARAMETER l',T56,':'\)
 1092 FORMAT(T8,'INPUT A VARIABLE NAME FOR SATURATED HYDRAULIC'/
     *T10,'CONDUCTIVITY',T56,':'\)
      WRITE(0,1095)
      ALOW=0.
      UP=1.0
      B(8)=REAL_RANGE(ALOW,UP)
      WRITE(0,1100)
      B(9)=REAL_RANGE(ALOW,UP)
      WRITE(0,1105)
      ALOW=0.
      UP=10000.
      B(10)=REAL_RANGE(ALOW,UP)
      WRITE(0,1110)
1193  B(11)=REAL_RANGE(ALOW,UP)
      IF(MTYPE .EQ. 1 .OR. MTYPE .EQ. 3) THEN
        IF (B(11) .LE. 1.) THEN
          WRITE(0,1500)
          GOTO 1193
         ENDIF
      ENDIF
      IF(MTYPE .EQ. 2 .OR. MTYPE .EQ. 4) THEN
        IF (B(11) .LE. 2.) THEN
          WRITE(0,1510)
          GOTO 1193
        ENDIF
      ENDIF
 1500 FORMAT(T10,'For the chosen model, n must be greater than 1.0'\)
 1510 FORMAT(T10,'For the chosen model, n must be greater than 2.0'\)
      WRITE(0,1115)
      B(12)=REAL_RANGE(ALOW,UP)
      WRITE(0,1120)
      B(13)=REAL_RANGE(ALOW,UP)
      WRITE(0,1125)
      B(14)=REAL_RANGE(ALOW,UP)
 1095 FORMAT(T8,'INPUT AN ESTIMATE FOR RESIDUAL WATER CONTENT',T56,':'
     *\)
 1100 FORMAT(T8,'INPUT AN ESTIMATE FOR SATURATED WATER CONTENT',T56,':'
     *\)
 1105 FORMAT(T8,'INPUT AN ESTIMATE FOR PARAMETER Alpha',T56,':',T56,':',
     *\)
 1110 FORMAT(T8,'INPUT AN ESTIMATE FOR PARAMETER n',T56,':'\)
 1115 FORMAT(T8,'INPUT AN ESTIMATE FOR PARAMETER m',T56,':'\)
 1120 FORMAT(T8,'INPUT AN ESTIMATE FOR PARAMETER l',T56,':'\)
 1125 FORMAT(T8,'INPUT AN ESTIMATE FOR SATURATED HYDRAULIC'/
     *T10,'CONDUCTIVITY',T56,':'\)
      IF (KWATER .EQ. 3) THEN
        MIT=0
        DO 1130 I=1,7
          INDEX(I)=0
 1130   CONTINUE
        GO TO 1295
      ENDIF
      WRITE(0,1260)
      INDEX(1)=INT_RANGE(0,1)
      WRITE(0,1265)
      INDEX(2)=INT_RANGE(0,1)
      WRITE(0,1270)
      INDEX(3)=INT_RANGE(0,1)
      WRITE(0,1275)
      INDEX(4)=INT_RANGE(0,1)
      WRITE(0,1280)
      INDEX(5)=INT_RANGE(0,1)
      WRITE(0,1285)
      INDEX(6)=INT_RANGE(0,1)
      WRITE(0,1290)
      INDEX(7)=INT_RANGE(0,1)
 1260 FORMAT(T8,'FITTING RESIDUAL WATER CONTENT'/
     *T12,'(0=No fitting;1=Fitting)',T56,'?'\)
 1265 FORMAT(T8,'FITTING SATURATED WATER CONTENT'/
     *T12,'(0=No fitting;1=Fitting)',T56,'?'\)
 1270 FORMAT(T8,'FITTING PARAMETER Alpha'/
     *T12,'(0=No fitting;1=Fitting)',T56,'?'\)
 1275 FORMAT(T8,'FITTING PARAMETER n',/
     *T12,'(0=No fitting;1=Fitting)',T56,'?'\)
 1280 FORMAT(T8,'FITTING PARAMETER m'/
     *T12,'(0=No fitting;1=Fitting)',T56,'?'\)
 1285 FORMAT(T8,'FITTING PARAMETER l'/
     *T12,'(0=No fitting;1=Fitting)',T56,'?'\)
 1290 FORMAT(T8,'FITTING FOR SATURATED HYDRAULIC CONDUCTIVITY'/
     *T12,'(0=No fitting;1=Fitting)',T56,'?'\)
 1295 WRITE(0,1300)
      W1=REAL_RANGE(ALOW,UP)
 1300 FORMAT(T8,'INPUT WEIGHT OF K/D DATA WITH RESPECT TO H, (Default=1)
     *',T65,':'\)
      WRITE(0,1035)
      NW=INT_RANGE(3,1000)
 1035 FORMAT(T8,'INPUT NUMBER OF PLOTTING POINTS FOR THE FITTING CURVES'
     *,T65,':'\)
      RETURN
      END
C
C     ------------------------------------------------------------------
      FUNCTION REAL_RANGE(ALOW,UP)
C
C     PURPOSE: CHECK FOR A REAL VALUE IN A RANGE
C
      IMPLICIT REAL*8(A-H,O-Z)
      IQZ=0
 10   READ(0,*,IOSTAT=IQZ,ERR=20) VAL
 20   CALL FIR_ER(IQZ)
      IF(IQZ .NE. 0) GO TO 10
      IF((UP .GT. 1000.0) .AND. (ALOW .GE. 0.)) THEN
        IF(VAL .LT. ALOW) THEN
          WRITE(*,30)
30        FORMAT(T10, 'Input should be a positive real number: '\)
          GO TO 10
        ENDIF
      ELSE
        IF(VAL .LT. ALOW .OR. VAL .GT. UP) THEN
          WRITE(*,35)ALOW,UP
35        FORMAT(T10, 'Input should be between',F5.2,' and ',F5.2,': '\)
          GO TO 10
        ENDIF
      ENDIF
      REAL_RANGE=VAL
      RETURN
      END
C
C     ------------------------------------------------------------------
      FUNCTION INT_RANGE(LOW,IUP)
C
C     PURPOSE: CHECK FOR AN INTEGER VALUE IN A RANGE
C
      IMPLICIT REAL*8(A-H,O-Z)
      IQZ=0
 10   READ(0,*,IOSTAT=IQZ,ERR=20) IVAL
 20   CALL FI_ER(IQZ)
      IF(IQZ .NE. 0) GO TO 10
      IF(IUP .GT. 100000) THEN
        IF(IVAL .LT. LOW) THEN
          WRITE(*,30) LOW
30        FORMAT(T10, 'Input should be equal to or greater then ',
     *I5,': ',\)
          GO TO 10
        ENDIF
      ELSE
        IF(IVAL .LT. LOW .OR. IVAL .GT. IUP) THEN
          WRITE(*,35)LOW,IUP
35        FORMAT(T10, 'Input should be between',I3,' and ',I3,': '\)
          GO TO 10
        ENDIF
      ENDIF
      INT_RANGE=IVAL
      RETURN
      END
C
C     ------------------------------------------------------------------
      SUBROUTINE GET_FI(INF,OTF,RETPLT,CONPLT,TITLE,MTYPE,
     *METHOD,KWATER,KIN,KOUT,KITER,MIT,AB,B,INDEX,W1,NW)
C
C     PURPOSE: READ CONTROL FILE RETC.CTL FROM DISK
C
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION B(14),INDEX(7)
      CHARACTER*60 TITLE
      CHARACTER*5 AB(14)
      CHARACTER*12 INF,OTF,RETPLT,CONPLT
      OPEN(5,FILE = 'RETC.CTL',STATUS = 'OLD')
      READ(5,1000) INF,OTF,RETPLT,CONPLT
      READ(5,1010) TITLE
      READ(5,*) MTYPE,METHOD,KWATER,KIN,KOUT,KITER,MIT
      READ(5,1020) (AB(I),I=8,14)
      READ(5,1025) (B(I),I=8,14)
      READ(5,1015) (INDEX(I),I=1,7)
      READ(5,1030) W1,NW
 1000 FORMAT(A12/A12/A12/A12)
 1005 FORMAT(2I5)
 1010 FORMAT(A60)
 1015 FORMAT(7I5)
 1020 FORMAT(8A5)
 1025 FORMAT(8F10.5)
 1030 FORMAT(F10.5,I5)
      CLOSE(5)
      RETURN
      END
C
C     ------------------------------------------------------------------
      SUBROUTINE WR1_SC(INF,OTF,RETPLT,CONPLT,TITLE,MTYPE)
C
C     PURPOSE: WRITE FIRST PART OF CONTROL FILE TO SCREEN
C
      IMPLICIT REAL*8(A-H,O-Z)
      CHARACTER*60 TITLE
      CHARACTER*12 INF,OTF,RETPLT,CONPLT
      CALL CLR
      CALL FI_EX(INF,1)
C     CALL FI_EX(OTF,2)
      WRITE(0,1040)
 1040 FORMAT(20(1H*),'  RETC : LISTING OF CONTROL FILE  ',20(1H*))
      WRITE(0,1045) INF,OTF,RETPLT,CONPLT
 1045 FORMAT('  [1]',T8,'OBSERVED DATA FILE NAME',T51,': ',A12/
     *       '  [2]',T8,'OUTPUT FILE NAME',T51,': ',A12/
     *       '  [3]',T8,'PLOT FILE NAME FOR RETENTION CURVE',T51,': ',
     *A12/
     *       '  [4]',T8,'PLOT FILE NAME FOR CONDUCTIVITY/DIFFUSIVITY: '
     *,A12)
      WRITE(0,1050) TITLE
 1050 FORMAT('  [5]', T8,'TITLE OF CASE ',T51,':'/,T12,A55)
      WRITE(0,1055) MTYPE
 1055 FORMAT('  [6]',T8,'TYPE OF RETENTION/CONDUCTIVITY MODEL'
     * T51,':',I5/T10,'1. Retention: van Genuchten'/
     *            T10,'   Conductivity: Mualem'/
     *            T10,'2. Retention: van Genuchten'/
     *            T10,'   Conductivity: Burdine'/
     *            T10,'3. Retention: van Genuchten with m=1-1/n'/
     *            T10,'   Conductivity: Mualem'/
     *            T10,'4. Retention: van Genuchten with m=1-2/n'/
     *            T10,'   Conductivity: Burdine'/
     *            T10,'5. Retention: Brooks & Corey'/
     *            T10,'   Conductivity: Mualem'/
     *            T10,'6. Retention: Brooks & Corey'/
     *            T10,'   Conductivity: Burdine'/)
C
      RETURN
      END
C
C     ------------------------------------------------------------------
      SUBROUTINE WR2_SC(METHOD,KWATER,KIN,KOUT,KITER)
C
C     PURPOSE: WRITE SECOND PART OF CONTROL FILE TO SCREEN
C
      IMPLICIT REAL*8(A-H,O-Z)
      CALL CLR
      WRITE(0,1040)
 1040 FORMAT(20(1H*),'  RETC : LISTING OF CONTROL FILE  ',20(1H*))
      WRITE(0,1066) METHOD,KWATER
 1066 FORMAT('  [7]',T8,'TYPE OF CONDUCTIVITY/DIFFUSIVITY DATA',
     *T65,':',I5/T10,'1. Conductivity vs. water content'/
     *   T10,'2. As 1 with internal log transformation of conductivity'/
     *   T10,'3. Conductivity vs. pressure head'/
     *   T10,'4. As 3 with internal log transformation of conductivity'/
     *   T10,'5. Diffusivity vs. water content'/
     *   T10,'6. As 5 with internal log transformation of diffusivity'/
     */'  [8]',T8,'TYPE OF FITTING',T65,':',I5/
     *   T10,'0. Fitting retention and conductivity/diffusivity data'/
     *   T10,'1. Fitting retention data only'/
     *   T10,'2. Fitting conductivity/diffusivity data only'/
     *   T10,'3. No fitting (forward problem)'/)
      WRITE(0,1067) KIN,KOUT,KITER
 1067 FORMAT('  [9]',T8,'PRINT OBSERVED DATA BEFORE FITTING',T65,
     *':',I5/T12,'(0=Skip;1=Print)'/' [10]',T8,'PRINT ALL SOIL HYDRAULIC
     * PROPERTIES AFTER FITTING',T65,':',I5/T12,'(0=Skip;1=Print)'/
     *' [11]',T8,'PRINT IMPROVED ESTIMATES FOR FITTING PARAMETERS DURING
     *'/T8,'FIRST KITER ITERATIONS (KITER)',T65,':',I5/)
C
      RETURN
      END
C
C     ------------------------------------------------------------------
      SUBROUTINE WR3_SC(KWATER,MIT,AB,B,INDEX,W1,NW)
C
C     PURPOSE: WRITE SECOND PART OF CONTROL FILE TO SCREEN
C
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION B(14),INDEX(7)
      CHARACTER*5 AB(14)
      CALL CLR
      WRITE(0,1040)
 1040 FORMAT(20(1H*),'  RETC : LISTING OF CONTROL FILE  ',20(1H*))
      IF (KWATER .EQ. 3) THEN
        MIT=0
        DO 1050 I=1,7
          INDEX(I)=0
 1050   CONTINUE
      ENDIF
      WRITE(0,1068) MIT
 1068 FORMAT(' [12]',T8,'MAXIMUM NUMBER OF ITERATIONS ',T65,':',I5/)
      WRITE(0,1075) (AB(I),I=8,14)
 1075 FORMAT(1X,'[13]',T8,'PARAMETER NAME',T25,A5,T31,'|',T33,A5,T39,'|'
     *,T41,A5,T47,'|',T49,A5,T55,'|',T57,A5,T63,'|',T65,A5,T70,'|',T72,A
     *5)
      WRITE(0,1095) (B(I),I=8,14)
 1095 FORMAT(1X,'[14]',T8,'INITIAL ESTIMATE',T25,F5.2,T31,'|',T33,F5.2,T
     *39,'|',T41,F5.2,T47,'|',T49,F5.2,T55,'|',T57,F5.2,T63,'|',T65,F5.2
     *,T70,'|',T72,F8.2)
      WRITE(0,1099) (INDEX(I),I=1,7)
 1099 FORMAT(1X,'[15]',T8,'FITTING?',T25,I5,T31,'|',T33,I5,T39,'|',T41,I
     *5,T47,'|',T49,I5,T55,'|',T57,I5,T63,'|',T65,I5,T70,'|',T72,I5)
      WRITE(0,1098)
 1098 FORMAT(1X,T8,'   (0 = known parameter; remains constant during par
     *ameter estimation)'/1X,T8,'   (1 = unknown parameter to be fitted 
     *to data)'/)
      WRITE(0,1100) W1,NW
 1100 FORMAT(1X,'[16]',T8,'WEIGHT OF K/D DATA WITH RESPECT TO WATER CONT
     *ENT DATA',T68,':',F5.2/T8,'(Default=1.0)'/1X,'[17]',T8,'NUMBER OF
     * POINTS FOR PRINTING THE FITTED HYDRAULIC FUNCTIONS',T68,':',I5/)
C
      RETURN
      END
C
C     ------------------------------------------------------------------
      SUBROUTINE WRI_FI(INF,OTF,RETPLT,CONPLT,TITLE,MTYPE,
     *METHOD,KWATER,KIN,KOUT,KITER,MIT,AB,B,INDEX,W1,NW)
C
C     PURPOSE: WRITE UPDATED PARAMETERS TO CONTROL FILE
C
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION B(10),INDEX(7)
      CHARACTER*60 TITLE
      CHARACTER*5 AB(14)
      CHARACTER*12 INF,OTF,RETPLT,CONPLT
      OPEN(7,FILE = 'RETC.CTL',STATUS = 'UNKNOWN')
      WRITE(7,1000) INF,OTF,RETPLT,CONPLT
      WRITE(7,1010) TITLE
      WRITE(7,1015) MTYPE,METHOD,KWATER,KIN,KOUT,KITER,MIT
      WRITE(7,1020) (AB(I),I=8,14)
      WRITE(7,1025) (B(I),I=8,14)
      IF (KWATER .EQ. 3) THEN
        MIT=0
        DO 950 I=1,7
          INDEX(I)=0
 950   CONTINUE
      ENDIF
      WRITE(7,1015) (INDEX(I),I=1,7)
      WRITE(7,1030) W1,NW
 1000 FORMAT(A12/A12/A12/A12)
 1010 FORMAT(A60)
 1015 FORMAT(7I5)
 1020 FORMAT(8A5)
 1025 FORMAT(8F10.5)
 1030 FORMAT(F10.5,I5)
      CLOSE(7)
      RETURN
      END
C

C
C     ------------------------------------------------------------------
      SUBROUTINE GET_VA(INF,OTF,RETPLT,CONPLT,TITLE,MTYPE,METHOD,KWATER,
     *KIN,KOUT,KITER,MIT,AB,B,INDEX,W1,NW,IANS)
C
C     PURPOSE: GET ADJUSTED SETTINGS FOR CONTROL FILE
C
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION B(10),INDEX(7)
      CHARACTER*60 TITLE,CANS
      CHARACTER*5 AB(14)
      CHARACTER*12 INF,OTF,RETPLT,CONPLT
      CHARACTER*1 ANS
    5 CONTINUE
      WRITE(0,1000)
 1000 FORMAT(//1X,T8,'ENTER ITEM NUMBER TO BE CHANGED (RETURN FOR NEXT S
     1CREEN): '\)
      IQZ = 0
      READ(0,1010,ERR=10,IOSTAT=IQZ,END=10) IANS
   10 CALL FI_ER(IQZ)
      IF(IQZ.GT.0) GO TO 5
 1010 FORMAT(I5)
      IF(IANS.EQ.0) RETURN
      IF(((IANS.LE.12).AND.(IANS.GT.0)) .OR. (IANS .EQ. 17)) THEN
   15   IQZ = 0
        IF (IANS.EQ.5) THEN
           WRITE(0,1015)
 1015      FORMAT(20X,'ENTER NEW TITLE (RETURN TO QUIT): '\)
        ELSE
           WRITE(0,1016)
 1016      FORMAT(20X,'ENTER NEW VALUE (RETURN TO QUIT): '\)
        ENDIF
        READ(0,1018) CANS
 1018   FORMAT(A60)
        IF(CANS.EQ.' ') RETURN
        IF(IANS.EQ.1) THEN
          INF=CANS
          CALL FI_EX(INF,1)
        ENDIF
        IF(IANS.EQ.2) OTF = CANS
        IF(IANS.EQ.3) RETPLT = CANS
        IF(IANS.EQ.4) CONPLT = CANS
        IF(IANS.EQ.5) TITLE = CANS
   20   CALL FI_ER(IQZ)
        IF(IQZ.GT.0) GO TO 15
 1020   FORMAT(I5)
        IF( IANS.GT.5 ) THEN
          READ(CANS,1020,IOSTAT=IQZ,ERR=20) IDUM
        ENDIF
 1030   FORMAT(A60)
        IF(IANS.EQ.6) THEN
          IF( (IDUM.LE.6).AND.(IDUM.GE.1)  ) THEN
            MTYPE = IDUM
          ELSE
            WRITE(0,1045)
 1045       FORMAT(6X,'  Value must be an integer from 1 to 6')
            GO TO 15
          ENDIF
        ENDIF
        IF(IANS.EQ.7) THEN
        IF((IDUM.LE.6).AND.(IDUM.GE.1)  ) THEN
        METHOD = IDUM
        ELSE
        WRITE(0,1045)
        GO TO 15
        ENDIF
        ENDIF
        IF(IANS.EQ.8) THEN
        IF( (IDUM.LE.3).AND.(IDUM.GE.0)  ) THEN
        KWATER = IDUM
        ELSE
        WRITE(0,1050)
 1050   FORMAT(6X,'    Value must be an integer from 0 to 3')
        GO TO 15
        ENDIF
        ENDIF
        IF(IANS.EQ.9) THEN
          IF( (IDUM.EQ.1).OR.(IDUM.EQ.0)  ) THEN
            KIN = IDUM
          ELSE
            WRITE(0,1055)
 1055       FORMAT(6X,'    Value must be an integer of 0 or 1')
            GO TO 15
          ENDIF
        ENDIF
        IF(IANS.EQ.10) THEN
          IF( (IDUM.EQ.1).OR.(IDUM.EQ.0)  ) THEN
             KOUT = IDUM
          ELSE
            WRITE(0,1055)
            GO TO 15
          ENDIF
        ENDIF
        IF(IANS.EQ.11) THEN
        IF( IDUM.GT.0 ) THEN
            KITER = IDUM
          ELSE
            WRITE(0,1060)
 1060       FORMAT(6X,'  Value must be a positive integer')
            GO TO 15
          ENDIF
        ENDIF
        IF(IANS.EQ.12) THEN
        IF( IDUM.GE.0 ) THEN
            MIT = IDUM
          ELSE
            WRITE(0,1060)
            GO TO 15
          ENDIF
        ENDIF
        IF(IANS.EQ.17) THEN
        IF( IDUM.GT.3 ) THEN
            NW = IDUM
          ELSE
            WRITE(0,1080)
            GO TO 15
 1080       FORMAT(6X,'  Value must be an integer greater than 3')
          ENDIF
        ENDIF
        ELSE IF(IANS.EQ.16) THEN
   22     WRITE(0,1061)
 1061     FORMAT(/1X,T8,'ENTER NEW VALUE: '\)
          READ(0,1062) CANS
 1062     FORMAT(A10)
          IF(CANS.EQ.' ') RETURN
          READ(CANS,1063,IOSTAT=IQZ,END=25) W1
   25     CALL FIR_ER(IQZ)
          IF(IQZ.NE.0) GO TO 22
 1063     FORMAT(F10.0)
          IF(W1 .LT. 0) THEN
            PRINT *,'        Input should be a positive number.'
            GO TO 22
          ENDIF
 1065   FORMAT(F5.0)
      ELSE IF(IANS.EQ.13) THEN
        CALL GET_NA(AB,14)
      ELSE IF(IANS.EQ.14) THEN
        CALL GET_ES(AB,B,14,MTYPE)
      ELSE IF(IANS.EQ.15) THEN
        CALL GET_IN(AB,INDEX,7)
      ELSE
        WRITE(0,1070)
 1070 FORMAT(1X,T8,'YOUR ENTRY CANNOT BE ACCEPTED.'/T8,'WOULD YOU LIKE T
     *O TRY AGAIN? (Y/N)' \)
        READ(0,1075) ANS
 1075   FORMAT(1A)
        IF( (ANS.EQ.'Y').OR.(ANS.EQ.'y') ) GO TO 5
      ENDIF
      RETURN
      END

C     ------------------------------------------------------------------
      SUBROUTINE GET_OP(IOP)
C
C     PURPOSE: GET DESIRED OPTION TO WORK WITH RETC
C
      CHARACTER*2 CANS
    5 CALL CLR
      WRITE(0,1000)
 1000 FORMAT(70(1H*)/1X,1H*,68X,1H*/1X,1H*,T25,'LIST OF PROGRAM OPTIONS'
     *,T71,1H*,/1X,1H*,68X,1H*/1X,70(1H*))
      WRITE(0,1005)
 1005 FORMAT(/6X,'1:  EDIT CONTROL FILE'/
     *        6X,'2:  RUN PROGRAM, OPTION TO PRINT OUTPUT FILE'/
     *        6X,'3:  UPDATE FILE AND QUIT TO DOS'/
     *        6X,'4:  QUIT TO DOS WITHOUT UPDATE'/
     *        6X,'5:  VIEW FILE ON SCREEN OR PERFORM DOS COMMAND'//
     *4X,'ENTER SELECTION (1 - 5): '\)
   15 READ(0,1010) CANS
      IF( (CANS.EQ.' ').OR.(CANS.EQ.'  ') ) THEN
        IOP = -1
        WRITE(*,1025)
        GO TO 15
      ENDIF
 1010 FORMAT(A2)
      IQZ = 0
      READ(CANS,1020,ERR=10,IOSTAT=IQZ) IOP
 1020 FORMAT(I2)
   10 CALL FI_ER(IQZ)
      IF(IQZ.NE.0) THEN
        CALL PAUS
        GO TO 5
      ENDIF
      IF((IOP.LT.1) .OR. (IOP .GT. 5)) THEN
        WRITE(*,1025)
 1025   FORMAT(/4X, 'SELECTION IS BETWEEN 1 AND 5, TRY AGAIN:'\)
        GOTO 15
      ENDIF
      RETURN
      END
C
C     ------------------------------------------------------------------
      SUBROUTINE GET_NA(AB,NP)
C
C     PURPOSE: TO GET THE NAME FOR EACH PARAMETER
C
      CHARACTER*5 AB(14),ATMP
    5 CALL CLR
      WRITE(0,1000)
 1000 FORMAT(/1X,T30,'PARAMETER NAMES'/T14,'1',T18'|',T23,'2',T27,'|',T
     *32,'3',T36,'|',T41'4',T45,'|',T50,'5',T54,'|',T59,'6',T63,'|',T68
     *,'7')
      WRITE(0,1010) (AB(I),I=8,NP)
 1010 FORMAT(1X,T11,A5,T18,'|',T20,A5,T27,'|',T29,A5,T36,'|',T38,A5,T45,
     *'|',T47,A5,T54,'|',T56,A5,T63,'|',T65,A5)
   10 WRITE(0,1020)
 1020 FORMAT(/1X,T8,'ENTER NUMBER OF PARAMETER NAME TO BE CHANGED (RETUR
     *N TO QUIT): '\)
      READ(0,1030,IOSTAT=IQZ,ERR=15) ITMP
   15 CALL FI_ER(IQZ)
      IF(IQZ.NE.0) GO TO 10
      IANS=ITMP+7
      IF(IANS.EQ.7) RETURN
      IF((IANS.GT.14).OR.(IANS.LT.7)) THEN
      WRITE(0,1025)
 1025 FORMAT(/1X,T8,'Value should be an integer 1 to 7:'\)
      GO TO 5
      ENDIF
 1030 FORMAT(I5)
      WRITE(0,1040)
 1040 FORMAT(/1X,T8,'ENTER NEW NAME: '\)
      READ(0,1050) ATMP
      IF(ATMP.NE.' ') AB(IANS) = ATMP
 1050 FORMAT(A5)
C
      RETURN
      END
C
C     ------------------------------------------------------------------
      SUBROUTINE GET_ES(AB,B,NP,MTYPE)
C
C     PURPOSE: TO GET INITIAL ESTIMATES FOR PARAMETERS
C
      IMPLICIT REAL*8(A-H,O-Z)
      CHARACTER*10 CANS
      CHARACTER*5 AB(14)
      DIMENSION B(10)
    5 CALL CLR
      WRITE(0,1000)
 1000 FORMAT(/1X,T25,'INITIAL ESTIMATES FOR PARAMETERS'/T14,'1',T18,'|',
     *T23,'2',T27,'|',T32,'3',T36,'|',T41'4',T45,'|',T50,'5',T54,'|',T59
     *,'6',T63,'|',T68,'7')
      WRITE(0,1008) (AB(I),I=8,NP)
 1008 FORMAT(1X,T11,A5,T18,'|',T20,A5,T27,'|',T29,A5,T36,'|',T38,A5,T45,
     *'|',T47,A5,T54,'|',T56,A5,T63,'|',T65,A5)
      WRITE(0,1010) (B(I),I=8,NP)
 1010 FORMAT(1X,T11,F6.2,T18,'|',T20,F6.2,T27,'|',T29,F6.2,T36,'|',T38,F
     *6.2,T45,'|',T47,F6.2,T54,'|',T56,F6.2,T63,'|',T65,F6.2)
   10 WRITE(0,1020)
 1020 FORMAT(/16X,'ENTER NUMBER OF PARAMETER TO BE CHANGED (RETURN TO QU
     *IT): '\)
      READ(0,1030,IOSTAT=IQZ,END=15) ITMP
   15 CALL FI_ER(IQZ)
      IF(IQZ.NE.0) GO TO 10
 1030 FORMAT(I5)
      IANS=ITMP+7
      IF(IANS.EQ.7) RETURN
      IF((IANS.GT.14).OR.(IANS.LT.6)) THEN
        WRITE(0,1025)
 1025   FORMAT(/1X,T8,'Value should be an integer 1 to 7')
        GO TO 5
      ENDIF
   20 WRITE(0,1040)
 1040 FORMAT(/1X,T8,'ENTER NEW VALUE: '\)
      READ(0,1045) CANS
 1045 FORMAT(A10)
      IF(CANS.NE.' ') READ(CANS,1050,IOSTAT=IQZ,END=25) B(IANS)
   25 CALL FIR_ER(IQZ)
      IF(IQZ.NE.0) GO TO 20
 1050 FORMAT(F10.0)
      IF(IANS .EQ. 8 .OR. IANS .EQ. 9 .OR. IANS .EQ. 12) THEN
        IF(B(IANS) .LT. 0 .OR. B(IANS) .GT. 1.) THEN
          PRINT *,'        Input should be between 0 and 1.0.'
          GO TO 20
        ENDIF
      ELSE IF(IANS .EQ. 10 .OR. IANS .EQ. 13 .OR. IANS .EQ. 14) THEN
        IF(B(IANS) .LT. 0) THEN
          PRINT *,'        Input should be a positive number.'
          GO TO 20
        ENDIF
      ElSE
      IF(MTYPE .EQ. 1 .OR. MTYPE .EQ. 3) THEN
        IF (B(11) .LE. 1.) THEN
          WRITE(0,1500)
          GOTO 20
         ENDIF
      ENDIF
      IF(MTYPE .EQ. 2 .OR. MTYPE .EQ. 4) THEN
        IF (B(11) .LE. 2.) THEN
          WRITE(0,1510)
          GOTO 20
        ENDIF
      ENDIF
      ENDIF
 1500 FORMAT(T10,'For the chosen model, n must be greater than 1.0'\)
 1510 FORMAT(T10,'For the chosen model, n must be greater than 2.0'\)
      RETURN
      END
C
C     ------------------------------------------------------------------
      SUBROUTINE GET_IN(AB,INDEX,NP)
C
C     PURPOSE: TO GET INDEX VALUES FOR EACH PARAMETER; 0=FIXED,1=FITTING
C
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION INDEX(7)
      CHARACTER*5 CANSB
      CHARACTER*5 AB(14)
    5 CALL CLR
      WRITE(0,1000)
 1000 FORMAT(/1X,T8,'PARAMETER IS CONSTANT (0) OR UNKNOWN TO BE FITTED T
     *O DATA (1)'/T14,'1',T18,'|',T23,'2',T27,'|',T32,'3',T36,'|',T41'4'
     *,T45,'|',T50,'5',T54,'|',T59,'6',T63,'|',T68,'7')
      NDUMP=NP+7
      WRITE(0,1008) (AB(I),I=8,NDUMP)
 1008 FORMAT(1X,T11,A5,T18,'|',T20,A5,T27,'|',T29,A5,T36,'|',T38,A5,T45,
     *'|',T47,A5,T54,'|',T56,A5,T63,'|',T65,A5)
      WRITE(0,1010) (INDEX(I),I=1,NP)
 1010 FORMAT(1X,T12,I3,T18,'|',T21,I3,T27,'|',T30,I3,T36,'|',T39,I3,T45,
     *'|',T48,I3,T54,'|',T57,I3,T63,'|',T66,I3)
   10 WRITE(0,1020)
 1020 FORMAT(/1X,T8,'ENTER NUMBER OF PARAMETER TO BE CHANGED (RETURN TO 
     *QUIT): '\)
      READ(0,1030,IOSTAT=IQZ,END=15) IANS
   15 CALL FI_ER(IQZ)
      IF(IQZ.NE.0) GO TO 10
      IF(IANS.EQ.0) RETURN
      IF((IANS.GT.7).OR.(IANS.LT.0)) THEN
      WRITE(0,1025)
 1025 FORMAT(/1X,T8,'Value should be an integer 1 to 7')
      GO TO 5
      ENDIF
 1030 FORMAT(I5)
   20 WRITE(0,1040)
 1040 FORMAT(/1X,T8,'ENTER NEW VALUE: '\)
      READ(0,1050) CANSB
 1050 FORMAT(A5)
      IF(CANSB.EQ.' ') RETURN
      READ(CANSB,1030,IOSTAT=IQZ,END=25) IDUM
c     IF( (IDUM.EQ.1).OR.(IDUM.EQ.0) ) INDEX(IANS) = IDUM
   25 CALL FI_ER(IQZ)
      IF(IQZ.NE.0) GO TO 20
      IF( (IDUM.LT.0).OR.(IDUM.GT.1) ) THEN
        WRITE(0,1060)
 1060   FORMAT(1X,T8,'    Value should be 0 or 1')
        GO TO 20
      ENDIF
      INDEX(IANS) = IDUM
      RETURN
      END
C
C     ------------------------------------------------------------------
      SUBROUTINE FI_EX(FIL,ICASE)
C
C     PURPOSE: TO PREVENT OVERWRITING OF AN EXISTING FILE (EXCEPT FOR
C              RETC.OUT)
C
      LOGICAL QEX
      CHARACTER*12 FIL
      INQUIRE(FILE=FIL,EXIST=QEX)
      IF( (.NOT.QEX).AND.(ICASE.EQ.1) ) FIL = '*MISSING*'
      IF( (QEX) .AND. (ICASE .NE. 1) ) THEN
        CALL CLR
        IF(ICASE.EQ.2) THEN
          WRITE(0,1000)
          FIL = 'RETC.OUT'
        ENDIF
        IF(ICASE.EQ.3) THEN
          WRITE(0,1010)
          FIL= 'RETPLT.OUT'
        ENDIF
        IF(ICASE.EQ.4) THEN
          WRITE(0,1020)
          FIL= 'CONPLT.OUT'
        ENDIF
        CALL PAUS
      ENDIF
      RETURN
 1000 FORMAT(10(/),14X,'OUPUT FILE ALREADY EXISTS.  OUTFILE SET TO RETC.
     *OUT'/)
 1010 FORMAT(10(/),8X,'PLOT FILE FOR RETENTION ALREADY EXISTS. PLOT FILE
     * SET TO RETPLT.OUT'/)
 1020 FORMAT(10(/),15X,'PLOT FILE FOR CONDUCTIVITY/DIFFUSIVITY ALREADY E
     *XISTS.'/24X,' PLOT FILE SET TO CONPLT.OUT')
      END
C
C     ------------------------------------------------------------------
      SUBROUTINE VI_FI(INF,OTF,RETPLT,CONPLT)
C
C     PURPOSE: TO WRITE FILES TO THE SCREEN OR USE DOS COMMANDS
C
      CHARACTER*1 ANS
      CHARACTER*12 INF,OTF,RETPLT,CONPLT
    1 CALL CLR
      WRITE(0,1000)
 1000 FORMAT(70(1H*)/1X,1H*,68X,1H*/1X,1H*,T32,'DOS COMMANDS',T71,1H*,/1
     *X,1H*,68X,1H*/1X,70(1H*)/)
      WRITE(0,1005) INF,OTF
 1005 FORMAT(6X,5(1H-),'FILE NAMES',5(1H-)/T8,'OBSERVED DATA',T46,': ',A
     *12/T8,'OUTPUT',T46,': ',A12/T8,'CONTROL FILE',T46,': RETC.CTL')
      WRITE(0,1006) RETPLT,CONPLT
 1006 FORMAT(1X,T8,'PLOT FILE FOR RETENTION CURVE',T46,': ',A12/
     *T8,'PLOT FILE FOR CONDUCTIVITY/DIFFUSIVITY: ',A12/)
      WRITE(0,1010)
 1010 FORMAT(/7X,'WRITE THE ABOVE OR ANY OTHER FILE TO THE SCREEN BY TYP
     *ING THE COMMAND'//'                 "VIEW filename"'//7X,'TYPE ANY
     * DOS COMMAND (EXCEPT FOR PRINT)'//7X,'TO PRINT THE OUTPUT FILE,', 
     *' HIT RETURN TWICE, TYPE "N", AND SELECT OPTION 2'/)
C
C     -----THIS COMMAND IS NOT FORTRAN 77 STANDARD-----
      PAUSE '      ENTER A COMMAND:  '
      CALL PAUS
      WRITE(0,1015)
 1015 FORMAT(1X,T8,'DO YOU WISH TO VIEW MORE FILES OR PERFORM OTHER DOS
     *COMMANDS? (Y/N): '\)
      READ(0,1020) ANS
 1020 FORMAT(A1)
      IF( (ANS.EQ.'Y').OR.(ANS.EQ.'y') ) GO TO 1
      RETURN
      END
C
C     ------------------------------------------------------------------
      SUBROUTINE PAUS
C
C     PURPOSE: TO HOLD OUTPUT ON THE SCREEN
C
      WRITE(0,1000)
      READ(0,1001) IDUM
 1000 FORMAT(/29X,'HIT RETURN TO CONTINUE')
 1001 FORMAT(I1)
      RETURN
      END
C
C     ------------------------------------------------------------------
      SUBROUTINE CLR
C
C     PURPOSE: TO CLEAR THE SCREEN
C
      CHARACTER*1 ESC,BRK
      CHARACTER*2 END
      ESC = CHAR(27)
      BRK = '['
      END = '2J'
      WRITE(0,1000) ESC,BRK,END
 1000 FORMAT(1X,2A1,A2\)
      RETURN
      END
C
C     ------------------------------------------------------------------
      SUBROUTINE STOPS
C
C     PURPOSE: TO EXIT PROGRAM
C
      CALL CLR
      STOP
      RETURN
      END
C
C     ------------------------------------------------------------------
      SUBROUTINE FI_ER(IQQXZ)
C
C     PURPOSE: TO FIND ERRORS IN DATA TYPE OF INTEGER VARIABLES
C
      IF(IQQXZ.EQ.0) RETURN
      IF(IQQXZ.EQ.6101) WRITE(0,1010)
 1010 FORMAT(T10,'You entered a real or a character. Please enter an int
     *eger: '\)
      RETURN
      END
C     --------------------------------------------------------------
      SUBROUTINE FIR_ER(IQQXZ)
C
C     PURPOSE: TO FIND ERRORS IN DATA TYPE OF RERAL VARIABLES
C
      IF(IQQXZ.EQ.0) RETURN
      IF(IQQXZ.EQ.6103) WRITE(0,1020)
 1020 FORMAT(T10,'You entered a character. Please enter a real: '\)
      RETURN
      END
